diff --git a/docs/reST/ref/surface.rst b/docs/reST/ref/surface.rst
index c3434a70f..e8e1321b4 100644
--- a/docs/reST/ref/surface.rst
+++ b/docs/reST/ref/surface.rst
@@ -768,6 +768,9 @@
 
       This is not needed for normal pygame usage.
 
+      .. note:: In SDL2, the masks are read-only and accordingly this method will raise
+                an AttributeError if called.
+
       .. versionadded:: 1.8.1
 
       .. ## Surface.set_masks ##
@@ -791,6 +794,9 @@
 
       This is not needed for normal pygame usage.
 
+      .. note:: In SDL2, the shifts are read-only and accordingly this method will raise
+                an AttributeError if called.
+
       .. versionadded:: 1.8.1
 
       .. ## Surface.set_shifts ##
diff --git a/src_c/surface.c b/src_c/surface.c
index f4098321e..bd1748a23 100644
--- a/src_c/surface.c
+++ b/src_c/surface.c
@@ -2679,18 +2679,17 @@ surf_set_masks(PyObject *self, PyObject *args)
     if (!surf)
         return RAISE(pgExc_SDLError, "display Surface quit");
 
-    /*
-    printf("passed in: %d, %d, %d, %d\n", r,g,b,a );
-    printf("what are: %d, %d, %d, %d\n", surf->format->Rmask,
-    surf->format->Gmask, surf->format->Bmask, surf->format->Amask);
-    */
-
+#if IS_SDLv2
+    PyErr_SetString(PyExc_AttributeError, "The surface masks are read-only in SDL2");
+    return NULL;
+#else /* IS_SDLv1 */
     surf->format->Rmask = (Uint32)r;
     surf->format->Gmask = (Uint32)g;
     surf->format->Bmask = (Uint32)b;
     surf->format->Amask = (Uint32)a;
 
     Py_RETURN_NONE;
+#endif /* IS_SDLv1 */
 }
 
 static PyObject *
@@ -2715,12 +2714,17 @@ surf_set_shifts(PyObject *self, PyObject *args)
     if (!surf)
         return RAISE(pgExc_SDLError, "display Surface quit");
 
+#if IS_SDLv2
+    PyErr_SetString(PyExc_AttributeError, "The surface shifts are read-only in SDL2");
+    return NULL;
+#else /* IS_SDLv1 */
     surf->format->Rshift = (Uint8)r;
     surf->format->Gshift = (Uint8)g;
     surf->format->Bshift = (Uint8)b;
     surf->format->Ashift = (Uint8)a;
 
     Py_RETURN_NONE;
+#endif /* IS_SDLv1 */
 }
 
 static PyObject *
